## Dependencies:

- io.grpc:grpc-netty-shaded
- io.grpc:grpc-protobuf
- io.grpc:grpc-stub

w/ **Gradle**
```
compile 'io.grpc:grpc-netty-shaded:' + grpc_java_version
compile 'io.grpc:grpc-protobuf:' + grpc_java_version
compile 'io.grpc:grpc-stub:' + grpc_java_version
```

w/ **Maven**
```
<dependency>
    <groupId>io.grpc</groupId>
    <artifactId>grpc-netty-shaded</artifactId>
    <version>${grpc_java_version}</version>
</dependency>
<dependency>
    <groupId>io.grpc</groupId>
    <artifactId>grpc-protobuf</artifactId>
    <version>${grpc_java_version}</version>
</dependency>
<dependency>
    <groupId>io.grpc</groupId>
    <artifactId>grpc-stub</artifactId>
    <version>${grpc_java_version}</version>
</dependency>
```

## Usage

See Javadoc and `src/test/java/bdchain/api/*Tests.java` files.

## Testing

1. Download [mock servers](https://public.internetapi.cn/?dir=bdchain/test) for Transaction Ledger &
 Accounting Chain
2. Run mock servers with ```--port={{port}}```
3. Run ```gradle test```
