package bdledger.api;

public class Utils {

  public static byte[] hexStringToByteArray(String s) {
    if (s.startsWith("0x")) {
      s = s.substring(2);
    }
    int l = s.length();
    byte[] data = new byte[l / 2];
    for (int i = 0; i < l; i += 2) {
      data[i / 2] =
          (byte) ((Character.digit(s.charAt(i), 16) << 4) + Character.digit(s.charAt(i + 1), 16));
    }
    return data;
  }

  public static String byteArrayToHexString(byte[] bs) {
    StringBuilder data = new StringBuilder();
    for (byte b : bs) {
      data.append(Integer.toHexString((b >> 4) & 0xf));
      data.append(Integer.toHexString(b & 0xf));
    }
    return data.toString();
  }
}
